package com.adventurer_engine.common.entity.ai.branch_nodes.control;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.adventurer_engine.common.entity.ai.AIObject;
import com.adventurer_engine.common.entity.ai.NodeBase;
import com.adventurer_engine.common.entity.ai.NodeStatus;
import com.adventurer_engine.common.entity.ai.branch_nodes.ControlNode;

public class RecursiveNode extends ControlNode {
  private int currentIdx = 0;
  
  public static final String INTERNAL_NAME = "recursive";
  
  public RecursiveNode(AIObject ai) {
    super(ai);
  }
  
  public NodeStatus onChildReportRUNNING() {
    return NodeStatus.RUNNING;
  }
  
  public NodeStatus onChildReportSUCCESS() {
    this.currentIdx = (this.currentIdx + 1) % this.child.size();
    return executeChildNode(this.currentIdx);
  }
  
  public NodeStatus onChildReportFAILURE() {
    this.currentIdx = (this.currentIdx + 1) % this.child.size();
    return executeChildNode(this.currentIdx);
  }
  
  public NodeStatus onParentSendInit() {
    if (this.child.isEmpty())
      throw new RuntimeException("Recursive Node must has at least one child"); 
    this.currentIdx = 0;
    return executeChildNode(this.currentIdx);
  }
  
  public void reset() {
    super.reset();
    this.currentIdx = 0;
  }
  
  public String internalName() {
    return "recursive";
  }
  
  public NodeBase copy(AIObject ai) {
    com.adventurer_engine.common.entity.ai.branch_nodes.control.RecursiveNode node = new com.adventurer_engine.common.entity.ai.branch_nodes.control.RecursiveNode(ai);
    node.child = copyChild(ai);
    return (NodeBase)node;
  }
}
